/*-----------------------------------------------------------------------

File  : clb_error.h

Author: Stephan Schulz

Contents
 
  Functions and datatypes for handling and reporting errors. 

Changes

<1> Sat Jul  5 02:20:53 MET DST 1997
    New

-----------------------------------------------------------------------*/

#ifndef CLB_ERROR

#define CLB_ERROR

#include "clb_defines.h"

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/

typedef enum
{
   NO_ERROR,
   OUT_OF_MEMORY,
   SYNTAX_ERROR,
   USAGE_ERROR,
   FILE_ERROR,
   SYS_ERROR
}ErrorCodes;

/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

#define MAX_ERRMSG_ADD   256
#define MAX_ERRMSG_LEN   MAX_ERRMSG_ADD+MAXPATHLEN

extern char  ErrStr[];
extern int   TmpErrno;
extern char* ProgName;

void          InitError(char* progname);
VOLATILE void Error(char* message, ErrorCodes ret);
VOLATILE void SysError(char* message, ErrorCodes ret);
void          Warning(char* message);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





