/*-----------------------------------------------------------------------

File  : clb_sysdate.c

Author: Stephan Schulz

Contents
 
  See clb_sysdate.h...this is extremely simple ;-)

Changes

<1> Wed Apr  8 19:51:08 MET DST 1998
    New

-----------------------------------------------------------------------*/

#include "clb_sysdate.h"



/*---------------------------------------------------------------------*/
/*                        Global Variables                             */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                      Forward Declarations                           */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                         Internal Functions                          */
/*---------------------------------------------------------------------*/



/*---------------------------------------------------------------------*/
/*                         Exported Functions                          */
/*---------------------------------------------------------------------*/

/*-----------------------------------------------------------------------
//
// Function:  SysDateCreationTime()
//
//   Return a representation of the earliest possible time.
//
// Global Variables: -
//
// Side Effects    : -
//
/----------------------------------------------------------------------*/

SysDate SysDateCreationTime()
{
   SysDate date;
   
   date.date = 0;
   
   return date;
}

/*-----------------------------------------------------------------------
//
// Function:  SysDateCompare()
//
//   Compare two times, return DateEqual, DateEarlier, DateLater,
//   if the first date is equal to, smaller or bigger than the second
//   one. 
//
// Global Variables: -
//
// Side Effects    : -
//
/----------------------------------------------------------------------*/

DateRelation SysDateCompare(SysDate date1, SysDate date2)
{
   if(date1.date > date2.date)
   {
      return DateLater;
   }
   else if(date1.date < date2.date)
   {
      return DateEarlier;
   }
   return DateEqual;
}


/*-----------------------------------------------------------------------
//
// Function: SysDatePrint()
//
//   Print  representation of a system time to the given channel.
//
// Global Variables: -
//
// Side Effects    : Output
//
/----------------------------------------------------------------------*/

void SysDatePrint(FILE* out, SysDate date)
{
   fprintf(out, "%5lu", date.date);
}

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/
