/*-----------------------------------------------------------------------

File  : ccl_rewrite.h

Author: Stephan Schulz

Contents
 
  Functions for rewriting terms and clauses with clause sets.

Changes

<1> Tue May 26 19:47:52 MET DST 1998
    New

-----------------------------------------------------------------------*/

#ifndef CCL_REWRITE

#define CCL_REWRITE

#include <cte_replace.h>
#include <ccl_pdtrees.h>
#include <ccl_clausesets.h>


/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/



extern long RewriteAttempts;
extern long RewriteSucesses;

#ifndef NDEBUG
extern bool RewriteWarnLeftSide;
#endif

Clause_p TermFindRewriteClause(OCB_p ocb, Term_p term, ClauseSet_p
			       demodulators, ClausePos_p pos, Subst_p
			       subst);

ClausePos_p TermIndexedFindDemodulator(OCB_p ocb, Term_p term,
				       ClauseSet_p demodulators,
				       Subst_p subst);

bool     TermRewriteWithClauseSet(OCB_p ocb, TB_p bank, Term_p term,
				  PDTree_p index, ClauseSet_p
				  demodulators); 
bool     TermComputeLINormalform(OCB_p ocb, TB_p bank, Term_p term,
				 PDTree_p index, ClauseSet_p
				 demodulators);

bool     EqnComputeLINormalform(OCB_p ocb, TB_p bank, Eqn_p eqn,
				PDTree_p index, EqnSide sides,
				ClauseSet_p demodulators);
bool     ClauseComputeLINormalform(OCB_p ocb, TB_p bank, Clause_p
				   clause, PDTree_p index, EqnSide
				   sides, ClauseSet_p demodulators);
bool     ClauseSetComputeLINormalform(OCB_p ocb, TB_p bank,
				      ClauseSet_p set,  PDTree_p
				      index, EqnSide sides,
				      ClauseSet_p demodulators);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





