/*-----------------------------------------------------------------------

File  : cto_proofproc.h

Author: Stephan Schulz

Contents
 
  Top level proof procedure

Changes

<1> Mon Jun  8 04:19:50 MET DST 1998
    New

-----------------------------------------------------------------------*/

#ifndef CTO_PROOFPROC

#define CTO_PROOFPROC

#include <cio_output.h>
#include <cco_simplification.h>
#include <cco_factoring.h>
#include <cco_eqnresolving.h>
#include <cco_paramodulation.h>
#include <ccl_subsumption.h>


/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/



/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

void     InitProofState(ProofState_p state, HeuristicParms_p h_parms);
Clause_p ProcessClause(ProofState_p state);
Clause_p Saturate(ProofState_p state, long step_limit, long
		  proc_limit, long unproc_limit, long total_limit);



#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





