/*-----------------------------------------------------------------------

File  : che_heu_exstandard.h

Author: Stephan Schulz

Contents
 
  Functions describing the standard heuristic for problems with
  variables in goal, interleaving ClauseAxiomWeight, FIFO and
  SimWeight.

Changes

<1> Mon Jun 29 00:37:45 MET DST 1998
    New

-----------------------------------------------------------------------*/

#ifndef CHE_HEU_EXSTANDARD

#define CHE_HEU_EXSTANDARD


#include <che_hcb.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/


#define EX_DEFAULT_WEIGHT_STEPS 4
#define EX_DEFAULT_SIM_STEPS    3
#define EX_DEFAULT_FIFO_STEPS   1


/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/


HCB_p HCBExStandardCreate(WFCBPARAMETERS);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





