/*-----------------------------------------------------------------------

File  : che_heu_fifo.c

Author: Stephan Schulz

Contents
 
  Functions describing the FIFO heuristic (may be used to hack
  rewriting...)

Changes

<1> Tue Jun  9 01:51:42 MET DST 1998
    New

-----------------------------------------------------------------------*/

#include "che_heu_fifo.h"



/*---------------------------------------------------------------------*/
/*                        Global Variables                             */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                      Forward Declarations                           */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                         Internal Functions                          */
/*---------------------------------------------------------------------*/



/*---------------------------------------------------------------------*/
/*                         Exported Functions                          */
/*---------------------------------------------------------------------*/


/*-----------------------------------------------------------------------
//
// Function: HCBFIFOtCreate()
//
//   Create a HCB entry for the FIFO heuristic.
//
// Global Variables: -
//
// Side Effects    : Memory operations
//
/----------------------------------------------------------------------*/

HCB_p HCBFIFOCreate(WFCBPARAMETERS)
{
   WFCB_p        wfcb;
   HCB_p         hcb     = HCBCellAlloc();
   
   wfcb = FIFOEvalInit(NULL, NULL, NULL, NULL, NULL, NULL);
   hcb->wfcb_list = wfcb;

   hcb->wfcb_no    = 1;
   hcb->hcb_select = HCBSingleWeightClauseSelect;
   hcb->hcb_exit   = NULL;
   hcb->data       = NULL;

   return hcb;
}


/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/


