/*-----------------------------------------------------------------------

File  : che_heu_lifo.c

Author: Stephan Schulz

Contents
 
  Functions describing the LIFO heuristic (may be used to hack
  rewriting...)

Changes

<1> Mon Jun 22 15:28:23 MET DST 1998
    New

-----------------------------------------------------------------------*/

#include "che_heu_lifo.h"


/*---------------------------------------------------------------------*/
/*                        Global Variables                             */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                      Forward Declarations                           */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                         Internal Functions                          */
/*---------------------------------------------------------------------*/



/*---------------------------------------------------------------------*/
/*                         Exported Functions                          */
/*---------------------------------------------------------------------*/


/*-----------------------------------------------------------------------
//
// Function: HCBLIFOtCreate()
//
//   Create a HCB entry for the LIFO heuristic.
//
// Global Variables: -
//
// Side Effects    : Memory operations
//
/----------------------------------------------------------------------*/

HCB_p HCBLIFOCreate(WFCBPARAMETERS)
{
   WFCB_p        wfcb;
   HCB_p         hcb     = HCBCellAlloc();
   
   wfcb = LIFOEvalInit(NULL, NULL, NULL, NULL, NULL, NULL);
   hcb->wfcb_list = wfcb;

   hcb->wfcb_no    = 1;
   hcb->hcb_select = HCBSingleWeightClauseSelect;
   hcb->hcb_exit   = NULL;
   hcb->data       = NULL;

   return hcb;
}


/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/


