/*-----------------------------------------------------------------------

File  : cio_output.h

Author: Stephan Schulz

Contents
 
  Simple functions for secure opening of output files with -
  convention and error checking. Much simpler than the input, because
  much less can go wrong with output...

Changes

<1> Fri Nov 28 11:55:59 MET 1997
    New

-----------------------------------------------------------------------*/

#ifndef CIO_OUTPUT

#define CIO_OUTPUT

#include <stdio.h>
#include <clb_dstrings.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/


#define OUTPRINT(level, message)\
    if(level<= OutputLevel){fprintf(GlobalOut, message);}


/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

extern long  OutputLevel;
extern FILE* GlobalOut;
FILE*        OutOpen(char* name);
void         OutClose(FILE* file);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





