/*-----------------------------------------------------------------------

File  : cto_kbo.h

Author: Joachim Steinbach

Contents
 
  Definitions for implementing a Knuth-Bendix ordering.

Changes

<1> Thu May 28 12:14:31 MET DST 1998
    New
<2> Mon Jul 13 19:16:03 MET DST 1998
    Changed checking of the variable condition - StS

-----------------------------------------------------------------------*/

#ifndef CTO_KBO

#define CTO_KBO

#include <cto_ocb.h>
#include <cte_varhash.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/


/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

CompareResult KBOVarCompare(Term_p s, Term_p t, DerefType deref_s,
			    DerefType deref_t);
bool          KBOVarGreater(Term_p s, Term_p t, DerefType deref_s,
			    DerefType deref_t);

bool          KBOGreater(OCB_p ocb, Term_p s, Term_p t, DerefType
			 deref_s, DerefType deref_t);

bool          KBOGreaterNew(OCB_p ocb, Term_p s, Term_p t, DerefType
			 deref_s, DerefType deref_t);

CompareResult KBOCompare(OCB_p ocb, Term_p t1, Term_p t2,
			 DerefType deref_t1, DerefType deref_t2);

CompareResult KBOCompareNew(OCB_p ocb, Term_p t1, Term_p t2,
			 DerefType deref_t1, DerefType deref_t2);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/
