/*-----------------------------------------------------------------------

File  : cto_orderings.h

Author: Stephan Schulz

Contents
 
  Generic Interface to the term comparison routines.

Changes

<1> Mon May  4 23:24:41 MET DST 1998
    New

-----------------------------------------------------------------------*/

#ifndef CTO_ORDERINGS

#define CTO_ORDERINGS

#include <cto_lpo.h>
/* #include <cto_rpo.h> */
#include <cto_kbo.h>


/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/




/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/


bool          TOGreater(OCB_p ocb, Term_p s, Term_p t, DerefType
			deref_s, DerefType deref_t); 
CompareResult TOCompare(OCB_p ocb, Term_p s, Term_p t, DerefType
			deref_s, DerefType deref_t);
void          TOGenerateDefaultPrecedence(OCB_p ocb, Sig_p sig);
void          TOGenerateDefaultWeights(OCB_p ocb, Sig_p sig);

PStackPointer TOSymbolComparisonParse(Scanner_p in, OCB_p ocb, Sig_p sig);
PStackPointer TOPrecedenceParse(Scanner_p in, OCB_p ocb, Sig_p sig);

OCB_p         TOGenerateDefaultOrdering(Sig_p sig);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/
