/*-----------------------------------------------------------------------

File  : cte_varmanip.h

Author: Stephan Schulz

Contents
 
  Functions (and a counter variable) for normalizing variables in
  terms.

Changes

<1> Mon Feb 16 12:25:42 MET 1998
    New

-----------------------------------------------------------------------*/

#ifndef CTE_VARMANIP

#define CTE_VARMANIP

#include <cte_terms.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/

typedef struct varmanipcell
{
   long      var_counter;
   NumTree_p var_map;
}VarManipCell, *VarManip_p;



/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

#define VarManipCellAlloc() (VarManipCell*)SizeMalloc(sizeof(VarManipCell))
#define VarManipCellFree(junk)         SizeFree(junk, sizeof(VarManipCell))

VarManip_p VarManipAlloc();
void       VarManipFree(VarManip_p junk);

long   TermComputeNormVars(Term_p term, VarManip_p newvars);
Term_p TermApplyVarRenaming(Term_p term,  VarManip_p newvars);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





