/*-----------------------------------------------------------------------

File  : cte_replace.h

Author: Stephan Schulz

Contents
 
  Functions for replacing and rewriting of terms.

Changes

<1> Mon Jan 12 17:50:21 MET 1998
    New

-----------------------------------------------------------------------*/

#ifndef CTE_REPLACE

#define CTE_REPLACE

#include <clb_pqueue.h>
#include <cte_termpos.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/

#define RPL_TERM_WATCH 2048

typedef struct replace_cell
{
   SysDate tb_date;
   Term_p  term;
   Term_p  repl;
}ReplaceCell, *Replace_p;


/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

#define ReplaceCellAlloc()     (ReplaceCell*)SizeMalloc(sizeof(ReplaceCell))
#define ReplaceCellFree(junk)  SizeFree(junk, sizeof(ReplaceCell))


void TBPropagateReplaceDataToSupers(TB_p bank, Term_p term, SysDate
				    ref_date);
void TBTermReplace(TB_p bank, Term_p term, Term_p replace);
void TBNonCyclicTermReplace(TB_p bank, Term_p term, Term_p replace);

Term_p TBTermPosReplace(TB_p bank, Term_p repl, TermPos_p pos,
			DerefType deref);


#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





