/*-----------------------------------------------------------------------

File  : cte_termfunc.h

Author: Stephan Schulz

Contents
 
  Most of the user-level functionality for unshared terms.

Changes

<1> Wed Feb 25 16:50:36 MET 1998
    Ripped from cte_terms.h (should be obsolete by now)

-----------------------------------------------------------------------*/

#ifndef CTE_TERMFUNC

#define CTE_TERMFUNC

#include <cte_termvars.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/




/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

extern bool      TermPrintLists; /* Using [...] notation */
extern bool      TermPrologVars; /* Capital words are variables */ 

#define TermStartToken (SigSupportLists?\
                       (SigIdentToken|Dollar|OpenSquare):\
		       (SigIdentToken|Dollar))

void   TermPrintConst(FILE* out, char* name);
void   TermPrint(FILE* out, Term_p term, Sig_p sig, DerefType deref);
void   TermPrintArgList(FILE* out, Term_p *args, int arity, Sig_p sig,
			DerefType deref);
bool   TermParseOperator(Scanner_p in, DStr_p id);
Term_p TermParse(Scanner_p in, Sig_p sig, VarBank_p vars);
int    TermParseArgList(Scanner_p in, Term_p** arg_anchor, Sig_p sig,
                         VarBank_p vars);
Term_p TermCopy(Term_p source, VarBank_p vars, DerefType deref);
Term_p TermEquivCellAlloc(Term_p source, VarBank_p vars);

bool   TermStructEqual(Term_p t1, Term_p t2);
bool   TermStructEqualNoDeref(Term_p t1, Term_p t2);

bool TermStructEqualDeref(Term_p t1, Term_p t2, DerefType deref_1,
			  DerefType deref_2);

bool   TermIsSubterm(Term_p super, Term_p test, DerefType deref,
                      TermEqualTestFun EqualTest);

bool    TermIsSubtermDeref(Term_p super, Term_p test, DerefType
			   deref_super, DerefType deref_test);

#define TermIsStructSubterm(super, term) \
        TermIsSubterm((super),(term),DEREF_ALWAYS,TermStructEqual)

long    TermWeight(Term_p term, long vweight, long fweight);

bool    TermHasVariables(Term_p term, bool unbound_only);
#define TermIsGround(term) (!TermHasVariables((term), false))
#define TermHasUnboundVariables(term) TermHasVariables((term), true)

long    VarBankCheckBindings(FILE* out, VarBank_p bank, Sig_p sig);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





